PROGRAM Kalender;         { ermittelt anhand des Datums, der wievielte }
                                               { Tag des Jahres es ist }
USES Crt;                                              { no comment... }

VAR  Day,                              { Dient der Aufnahme des Tages, }
     Monat,                             { des Monats und des Jahres... }
     Jahr    : INTEGER;

{**********************************************************************}
{ Die Funktion Schaltjahr berprft, ob es sich bei dem angegebenen    }
{ Jahr um ein Schaltjahr handelt. Dies ist der Fall, falls die Jahres- }
{ zahl durch 4, nicht aber durch 100 teilbar ist. Ferner mu berck-   }
{ sichtigt werden, da alle 400 Jahre ein Schaltjahr eingeschoben wird.}
{----------------------------------------------------------------------}
{ bergebener Parameter:                                               }
{                         j                 Jahreszahl                 }
{----------------------------------------------------------------------}
{ Rckgabewert:           True, falls j ein Schaltjahr, sonst False    }
{**********************************************************************}

FUNCTION Schaltjahr(j : INTEGER) : BOOLEAN;
BEGIN   { True, falls Jahreszahl durch 4, aber nicht durch 100 teilbar }
               { Ferner wird auerplanmig alle 400 Jahre ein Schalt- }
                                                { jahr eingeschoben... }
     Schaltjahr := (j MOD 4 = 0) AND (j MOD 100 <> 0)
                    OR (j MOD 400 = 0)
END;                                    { Ende der Funktion Schaltjahr }


{**********************************************************************}
{ Die Funktion Monatstage ermittelt die Anzahl der Tage eines Monats m }
{ im Jahr j. Dabei wird auch ein evtl. Schaltjahr bercksichtigt.      }
{----------------------------------------------------------------------}
{ bergebener Parameter:                                               }
{                         m                 Nummer des Monats          }
{                         j                 Jahreszahl                 }
{----------------------------------------------------------------------}
{ Rckgabewert:           Anzahl der Tage im Monat m                   }
{**********************************************************************}

FUNCTION Monatstage(m, j: INTEGER) : INTEGER;     { Tage des Monates m }
BEGIN
     CASE m OF                            { Welcher Monat ist es denn? }
       1,3,5,7,8,10,12: Monatstage := 31;     { Diese Monate haben 31, }
       4,6,9,11:        Monatstage := 30;             { diese 30 Tage! }
       2:               IF Schaltjahr(j) THEN    { Februar? Dann hngt }
                           Monatstage := 29  { es davon ab, ob es sich }
                        ELSE              { um ein Schaltjahr handelt! }
                           Monatstage := 28
     END
END;

{**********************************************************************}
{ Die Funktion Tag ermittelt die Anzahl der Tage des laufenden Jahres, }
{ die bereits verstrichen sind. Dazu werden die Tageszahlen der Vormo- }
{ nate aufaddiert und die Anzahl der Tage des laufenden Monats hinzu-  }
{ gezhlt.                                                             }
{----------------------------------------------------------------------}
{ bergebener Parameter:                                               }
{                         m                 Nummer des Monats          }
{                         j                 Jahreszahl                 }
{----------------------------------------------------------------------}
{ Rckgabewert:           Anzahl der Tage im Monat m                   }
{**********************************************************************}

FUNCTION Tag(t, m, j : INTEGER) : INTEGER;  { Tag des Jahres ermitteln }
VAR i, Tage : INTEGER;               { Wir verwenden lokalen Variablen }
BEGIN
     Tage := 0;                                    { mit 0 vorbesetzen }
     FOR i := 1 TO m - 1 DO       { fr alle Vormonate die Tageszahlen }
          Tage := Tage + Monatstage(i, j);    { ermitteln und addieren }
     Tag := Tage + t;       { dazu die Tage des angebrochenenen Monats }
END;                                { und als Funktionsergebnis zurck }

{**********************************************************************}
{ H A U P T P R O G R A M M                                            }
{**********************************************************************}

BEGIN                                 { Hier startet das Hauptprogramm }
     ClrScr;                                      { Bildschirm lschen }
     Write(' Tag: ');     { Hier erbrigt sich wohl jeder Kommentar... }
     ReadLn(Day);
     REPEAT
          Write(' Monat: ');
          ReadLn(Monat);
          IF (Monat > 0) AND (Monat <= 12) THEN
               Break;                        { Demonstration fr Break }
          WriteLn(' Falsche Eingabe!!');  { Nur im Fehlerfall ausgeben }
     UNTIL FALSE;                                { Eine Enlosschleife! }

     Write(' Jahr: ');
     ReadLn(Jahr);
     Day := Tag(Day, Monat, Jahr);         { Tag des Jahres ermitteln }
     Write(^j^j^j^j, ' Das ist der ', Day,'.Tag des Jahres ', Jahr);
     ReadKey;
END.


