{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 16384,0,655360}
(*===================================================================*)
(*                            MAKELOGO.PAS                           *)
(*                Copyright (C) 1993 te-wi Verlag, Mnchen           *)
(*-------------------------------------------------------------------*)
(*   Das Programm erzeugt drei Includedateien mit den Bitmaps fr    *)
(*                         TEWILOGO.PAS                              *)
(*===================================================================*)
PROGRAM MakeLogo;

USES
  DOS,                                           (* Dateioperationen *)
  Graph,                                        (* Grafikoperationen *)
  Drivers;                                            (* BGI-Treiber *)

VAR
  MaxX, MaxY,
  x, y, gd, gm, i  : INTEGER;
  p1, p2, p3       : Pointer;
  size             : WORD;
  ComplexFont,
  TriplexScriptFont: INTEGER;
  f1, f2, f3       : FILE;

(* Alle bentigten Fonts werden in das Programm eingelinkt *)
PROCEDURE SmallFontProc;         EXTERNAL; {$L LITT}
PROCEDURE TriplexScriptFontProc; EXTERNAL; {$L TSCR}
PROCEDURE ComplexFontProc;       EXTERNAL; {$L LCOM}

FUNCTION Byte2Hex(b: BYTE): STRING;
(* Die Funktion wandelt ein Byte in einen HexString um, der von      *)
(* einem '$'-Zeichen eingeleitet wird. Nicht sehr sauber, dafr      *)
(* aber schnell!                                                     *)
(* Sie knnen anstelle dieser Funktion auch die Unit Hex aus dem     *)
(* Dos-Kapitel verwenden!                                            *)
CONST
 HexCh: ARRAY[0..15] OF CHAR = '0123456789ABCDEF';

BEGIN
  Byte2Hex    := '$00';
  Byte2Hex[2] := HexCh[b DIV $10];
  Byte2Hex[3] := HexCh[b MOD $10];
END;

PROCEDURE MakeArray(n: STRING);
(* erzeugt ein ARRAY OF BYTE aus einer beliebigen Turbo-Pascal-      *)
(* Imagedatei. Das Array wird in eine Includedatei geschrieben       *)
VAR
  f    : FILE;
  t    : Text;
  o, s : WORD;
  dir  : DirStr;
  name : NameStr;
  ext  : ExtStr;
  l    : LongInt;
  i    : WORD;
  Buf  : Pointer;
  b    : BYTE;
BEGIN
  GetMem(Buf, 65528);          (* Puffer auf den Heap, 1 Segment-$08 *)
  FSplit(n, dir, name, ext);
  Assign(f, n);                                    (* Datei zuweisen *)
  Assign(t, dir + name + '.INC');      (* Namen fr Include zuweisen *)
  Reset(f, 1);        (* Binrdatei fr Blockread untypisiert ffnen *)
  l := FileSize(f);               (* Gre des Bildes aus Dateilnge *)
  BlockRead(f, Buf^, WORD(l));                        (* Datei lesen *)
  Close(f);                                  (* Binrdatei schlieen *)
  Rewrite(t);                                (* Textdatei neu-ffnen *)
  WriteLn(t, 'CONST');                           (* Header schreiben *)
  WriteLn(t, '  ', name, ' : ARRAY[1..', l, '] OF BYTE = (');
  Write(t, '    ');                                     (* einrcken *)
  o := Ofs(Buf^); s := Seg(Buf^);   (* Adresse des Puffers ermitteln *)
  FOR i := 1 TO WORD(l) DO BEGIN
    Move(Mem[s : o + i - 1], b, 1);       (*  Ein Byte herausfischen *)
    Write(t, Byte2Hex(b));                (* umwandeln und schreiben *)
    IF i < l THEN Write(t, ', ');         (* Zeichen durch , trennen *)
    IF i MOD 10 = 0 THEN BEGIN
      WriteLn(t, '');             (* Alle zehn Zeichen Zeilenumbruch *)
      Write(t, '    ');       (* und neue Einrckung um vier Zeichen *)
    END;
  END;
  WriteLn(t, ');');         (* Wenn alles erledingt, Array schlieen *)
  Close(t);                                   (* Textdatei schlieen *)
  FreeMem(Buf, 65528);       (* Puffer auf dem Heap wieder freigeben *)
END;

BEGIN                                        (* Fonts registrieren : *)
  TriplexScriptFont := RegisterBGIFont(@SmallFontProc);
  ComplexFont       := RegisterBGIFont(@ComplexFontProc);
  TriplexScriptFont := RegisterBGIFont(@TriplexScriptFontProc);
  DetectGraph(gd, gm);                           (* Grafik ermitteln *)
  InitGraph(gd, gm, '');                    (* Grafik initialisieren *)
  SetTextJustify(LeftText, BottomText);    (* Textausgaben initalis. *)
  SetFillStyle(SolidFill, Cyan);
  SetLineStyle(SolidLn, 0, ThickWidth);
  Bar(2, 2, 218, 68);                        (* erstes Bild zeichnen *)
  SetColor(Cyan);
  Rectangle(1, 1, 219, 69);
  SetColor(Red);
  Rectangle(4, 4, 216, 66);
  SetTextStyle(TriplexScriptFont, 0, 4);
  x := 10;
  y := 36;
  CASE gd OF
    EGA, VGA, EGA64: SetColor(White);
    ELSE             SetColor(Black);
  END;
  OutTextXY(x + 60, y, 'tewi');
  OutTextXY(x + 61, y, 'tewi');
  SetColor(Black);
  y := y + TextHeight('Pp') DIV 2 + 5;
  SetTextStyle(SmallFont, 0, 4);
  OutTextXY(x + 15, y, 'Die etwas bessere PC-Literatur');
  size := ImageSize(0, 0, 231, 70);    (* Bildgre errechnen lassen *)
  GetMem(p1, Size);                (* Speicher fr drei Bilder holen *)
  GetMem(p2, Size);
  GetMem(p3, Size);
  GetImage(0, 0, 231, 70, p1^);                  (* Bild 1 speichern *)
  SetFillStyle(SolidFill, Black);            (* und jetzt Bild 2 ... *)
  Bar(0, 0, 250, 70);
  GetImage(0, 0, 231, 70, p2^);                  (* Bild 2 speichern *)
  SetFillStyle(SolidFill, Red);              (* und jetzt Bild 3 ... *)
  Bar(2, 2, 218, 68);
  SetColor(LightRed);
  Rectangle(4, 4, 216, 66);
  SetColor(White);
  SetTextStyle(ComplexFont, 0, 3);
  OutTextXY(x + 18, y - 10, 'Falsche Taste');
  GetImage(0, 0, 231, 70, p3^);                  (* Bild 1 speichern *)
  Assign(f1, 'BITMAP1.PIC'); Rewrite(f1, 1);      (* Die Bilddateien *)
  Assign(f2, 'BITMAP2.PIC'); Rewrite(f2, 1);    (* zuordnen und auch *)
  Assign(f3, 'BITMAP3.PIC'); Rewrite(f3, 1);    (* gleich neu-ffnen *)
  BlockWrite(f1, p1^, size, i);                  (* Alle drei Bilder *)
  BlockWrite(f2, p2^, size, i);                       (* abspeichern *)
  BlockWrite(f3, p3^, size, i);
  Close(f1);                                (* und alle drei Dateien *)
  Close(f2);                                     (* wieder schlieen *)
  Close(f3);
  FreeMem(p1, Size);              (* Zum Schlu den Speicher fr die *)
  FreeMem(p2, Size);                      (* Bilder wieder freigeben *)
  FreeMem(p3, Size);
  CloseGraph;                              (* Grafikmodus abschalten *)
  WriteLn('Konvertiere Bilder in Arrays...');             (* Meldung *)
  MakeArray('BITMAP1.PIC');                   (* Bilder konvertieren *)
  MakeArray('BITMAP2.PIC');
  MakeArray('BITMAP3.PIC');
  WriteLn('Lsche Interimsdateien...');   (* PIC-Dateien lschen ... *)
  Erase(f1);
  Erase(f2);
  Erase(f3);
END.                                               (* ... und fertig *)

(*===================================================================*)