; ***************************************
; *        Autor : Robert Flogaus       *
; *        Datum : 24.4.1993            *
; *       Sprache: Turbo Assembler 2.0  *
; * Assemblierung: tasm chktsr          *
; *         Zweck: Assembler-Unterprog. *
; *                von chktsr.pas       *
; ***************************************

DATA SEGMENT
ASSUME DS:DATA
EXTRN Cmdline         :UNKNOWN
EXTRN PrgName         :UNKNOWN
EXTRN Stack_Test      :UNKNOWN
EXTRN Oldint_Ptr      :DWORD
EXTRN Newint_Ptr      :DWORD
EXTRN Program_Memory  :DWORD
EXTRN Data_Memory     :DWORD
EXTRN Env_Memory      :DWORD
EXTRN FSize           :DWORD
EXTRN FBlock          :DWORD
EXTRN DosError        :WORD
EXTRN PrefixSeg       :WORD
EXTRN Front_Buf_Bytes :WORD
EXTRN ChkTSR_Space    :WORD
EXTRN PrefixSeg       :WORD
EXTRN Termination_Type:WORD
EXTRN TsrPSP_Seg      :WORD
EXTRN Number_Of_Vecs  :BYTE
EXTRN JNChar          :BYTE
EXTRN No_Uninstall    :BYTE
EXTRN ErrorFlag       :BYTE
EXTRN Is_Exe          :BYTE
EXTRN Free_Env        :BYTE
EXTRN ExitCode        :BYTE
DATA ENDS

CODE SEGMENT BYTE
ASSUME CS:CODE
LOCALS
TRUE             EQU 1
FALSE            EQU 0
AXSave          EQU 100H
Flag             EQU 0
OwnerPSP         EQU 1
PSPNextParagraph EQU 2
BlockSize        EQU 3
Ignore           EQU 0
Fail             EQU 3
PrevAddr21       DD 0
PrevAddr27       DD 0
PrevAddr33       DD 0
TSRStatus        DB 0  ;0: normal
                       ;1: inaktiv
Mouse            DB FALSE

Int33h_Entry PROC NEAR
  CMP AX,0CH
  JE @@Handler_Installed
  CMP AX,14H
  JE @@Handler_Installed
  CMP AX,18H
  JNE @@Chain_33
@@Handler_Installed:
  MOV CS:[Mouse],TRUE
@@Chain_33:
  JMP CS:[PrevAddr33]
Int33h_Entry ENDP

Int27h_Entry PROC NEAR
ASSUME DS:NOTHING
    CLI
    TEST CS:[TSRStatus],1
    JNZ @@Cont
    MOV AX,CS
    MOV SS,AX
    MOV SP,OFFSET Stack_End
    MOV BX,DATA
    MOV DS,BX
ASSUME DS:DATA
    MOV AL,15
    AND AL,DL
    JZ @@Ok
    SUB DL,AL
    ADD DX,16
@@Ok:
    MOV WORD PTR [Program_Memory],DX
    ADC WORD PTR [Program_Memory+2],0
    MOV [Termination_Type],2700H
    JMP Terminate_TSR
@@Cont:
    JMP CS:[PrevAddr27]
Int27h_Entry ENDP

Int21h_Entry PROC NEAR
ASSUME DS:NOTHING
    TEST CS:[TSRStatus],1
    JNZ @@Cont
    CMP AH,31H
    JE TSR_21
@@Cont:
    JMP CS:[PrevAddr21]
TSR_21:
    CLI
    MOV BX,CS
    MOV SS,BX
    MOV SP,OFFSET Stack_End
    MOV BX,DATA
    MOV DS,BX
ASSUME DS:DATA
    CALL Mul16
    MOV WORD PTR [Program_Memory],DX
    MOV WORD PTR [Program_Memory+2],CX
    MOV [Termination_Type],AX
    JMP Terminate_TSR
Int21h_Entry ENDP

Env_Seg     DW 0
Int_Changed DB 256 DUP (FALSE)
Prog2Exec   DB 80 DUP (0)
PrgCmdLine  DB 132 DUP (0)
FCB1        DB 37 DUP (0)
FCB2        DB 37 DUP (0)
            DW 128 DUP (0)
Stack_End:
LoadPars:
LdEnvSeg        DW 0
LdCmdLinePtr    DD 0
LdFCB1Ptr       DD 0
LdFCB2Ptr       DD 0
LdSP            DW 0
LdSS            DW 0
LdCSIP          DD 0
Start_Progsize  DW 0
Int24h_Strategy DB Ignore

Int24h_Entry:
  MOV AL,CS:[Int24h_Strategy]
  IRET

Keep_Prog PROC NEAR
PUBLIC Keep_Prog
ASSUME DS:DATA
  MOV BX,[PrefixSeg]
  MOV AX,CS
  MOV DS,AX
ASSUME DS:CODE
  SUB AX,BX
  MOV DX,OFFSET TSR_21+15
  MOV CL,4
  SHR DX,CL
  ADD DX,AX
  MOV [TSRStatus],1    ;1:ignore TSRs
  MOV AX,3101H
  INT 21H      ;terminate+stay resident
Keep_Prog ENDP

Get_Calc_Start_Progsize PROC NEAR
PUBLIC Get_Calc_Start_Progsize
ASSUME DS:DATA
  LES DI,FBlock
  MOV AX,ES:[DI+0CH] ;max. heap paras
  CMP AX,0FFFFH
  JNE @@Less_Than_Maximum
@@Maximum:
  MOV AX,0FFFFH
  MOV DX,0FFFFH
  RET
@@Less_Than_Maximum:
  ADD AX,10H ;PSP seg
  SUB AX,ES:[DI+8] ;header size (paras)
  MOV DX,WORD PTR [FSize]
  MOV CX,WORD PTR [FSize+2]
  ADD DX,15
  ADC CX,0
  CALL Div16
  ADD DX,AX
  CALL Mul16
  MOV AX,DX
  MOV DX,CX
  RET
Get_Calc_Start_Progsize ENDP

Get_Actual_Start_Progsize PROC NEAR
PUBLIC Get_Actual_Start_Progsize
  MOV DX,CS:[Start_Progsize]
  CALL Mul16
  MOV AX,DX
  MOV DX,CX
  RET
Get_Actual_Start_Progsize ENDP

Get_TSRProg_Space PROC NEAR
PUBLIC Get_TSRProg_Space
ASSUME DS:DATA
  MOV AX,OFFSET ProgName
  CMP [Is_Exe],TRUE
  JE @@Is_Exe
  SUB AX,OFFSET Start_TSRProg
  RET
@@Is_Exe:
  SUB AX,OFFSET EXE_Data
  RET
Get_TSRProg_Space ENDP

Get_Int_ChangedAdd PROC NEAR
PUBLIC Get_Int_ChangedAdd
  MOV DX,CS
  MOV AX,OFFSET Int_Changed
  RET
Get_Int_ChangedAdd ENDP

Get_TSRProg_Add PROC NEAR
PUBLIC Get_TSRProg_Add
ASSUME DS:DATA
  MOV DX,CS
  CMP [Is_Exe],TRUE
  JE @@Is_Exe
  MOV AX,OFFSET Start_TSRProg
  RET
@@Is_Exe:
  MOV AX,OFFSET EXE_Data
  RET
Get_TSRProg_Add ENDP

Get_Writeback_Space PROC NEAR
PUBLIC Get_Writeback_Space
ASSUME DS:DATA
  CMP [Is_Exe],TRUE
  JE @@Is_Exe
  MOV AX,OFFSET End_Writeback
  SUB AX,OFFSET Writeback
  RET
@@Is_Exe:
  MOV AX,OFFSET Start_TSRProg
  SUB AX,OFFSET EXE_Data
  ADD AX,210H ;stack
  ADD AX,[Front_Buf_Bytes]
  RET
Get_Writeback_Space ENDP

Get_Writeback_Add PROC NEAR
PUBLIC Get_Writeback_Add
MOV AX,OFFSET Writeback
MOV DX,CS
RET
Get_Writeback_Add ENDP

Mouse_Used PROC NEAR
PUBLIC Mouse_Used
  MOV AL,CS:[Mouse]
  RET
Mouse_Used ENDP

Get_Old_FSize PROC NEAR
PUBLIC Get_Old_FSize
  ASSUME DS:DATA
  MOV SI,OFFSET CS:Save_FSize
Get_Old:
  SUB SI,OFFSET CS:Start_TSRProg
  LES DI,FBlock
  ADD DI,SI
  MOV AX,ES:[DI]
  RET
Get_Old_FSize ENDP

Get_Old_ChkTSR_Space PROC NEAR
PUBLIC Get_Old_ChkTSR_Space
  ASSUME DS:DATA
  MOV SI,OFFSET CS:Save_ChkTSR_Space
  JMP Get_Old
Get_Old_ChkTSR_Space ENDP

BlkSize   EQU WORD PTR  [BP+4]
Ptr2Ptr   EQU DWORD PTR [BP+6]
TempPtr   DD 0

DOSGetMem PROC NEAR
PUBLIC DOSGetMem
  PUSH BP
  MOV BP,SP
  MOV AH,48H
  MOV BX,[BlkSize]
  ADD BX,15
  MOV CL,4
  SHR BX,CL
  INT 21H
  JC @@Error
  LES DI,Ptr2Ptr
  MOV WORD PTR ES:[DI],0
  MOV WORD PTR ES:[DI+2],AX
  MOV AL,TRUE
@@Terminate:
  POP BP
  RET 6
@@Error:
  XOR AX,AX
  JMP @@Terminate
DOSGetMem ENDP

ReSizeBlock PROC NEAR
PUBLIC ReSizeBlock
  PUSH BP
  MOV BP,SP
  LES DI,Ptr2Ptr
  MOV DX,WORD PTR ES:[DI+2] ;seg block
  MOV AX,DX
  DEC AX
  MOV ES,AX  ;seg mcb of block
  MOV AH,4AH
  MOV BX,[BlkSize]
  ADD BX,15
  MOV CL,4
  SHR BX,CL
  MOV CX,ES:[BlockSize]
  MOV ES,DX  ;seg block
  INT 21H
  JC @@New_Block_Necessary
  MOV AL,TRUE
@@Terminate:
  POP BP
  RET 6
@@New_Block_Necessary:
  CMP AX,8
  JNE @@Error
  PUSH CX ;paras old block
  PUSH ES ;seg old block
  PUSH CS
  MOV AX,OFFSET TempPtr
  PUSH AX
  PUSH [BlkSize]
  CALL DOSGetMem
  OR AL,AL
  POP AX  ;seg old block
  POP CX  ;paras old block
  JZ @@Error
  PUSH DS
  MOV DS,AX
  XOR SI,SI
  LES DI,CS:[TempPtr] ;new block
  SHL CX,1
  SHL CX,1
  SHL CX,1  ;words old block
  CLD
  REP MOVSW ;copy block
  PUSH ES   ;seg new block
  PUSH DS   ;seg old block
  POP ES
  MOV AH,49H  ;release old block
  INT 21H
  LDS SI,Ptr2Ptr
  POP [SI+2]  ;seg new block
  POP DS
  MOV AL,TRUE
  JMP @@Terminate
@@Error:
  XOR AX,AX
  JMP @@Terminate
ReSizeBlock ENDP

Readkey PROC NEAR
  MOV AH,8
  INT 21H
  RET
Readkey ENDP

Read_Line PROC NEAR
PUBLIC Read_Line

LenStr EQU BYTE  PTR SS:[BX+2]
SPtr   EQU DWORD PTR SS:[BX+4]

  CLD
  MOV BX,SP
  XOR CX,CX
  MOV CL,[LenStr] ;max. length
  LES DI,SPtr
  INC DI ;first data byte of sptr^
  MOV BX,DI
  JCXZ @@Terminate
  INC CX
@@ReadLoop:
  CALL Readkey
  OR AL,AL
  JZ @@Is_Zero
  CMP AL,8
  JE @@Is_Backspace
  CMP AL,13
  JE @@Is_Cr
  CMP AL,32
  JBE @@ReadLoop
  CMP AL,'a'
  JB @@Write
  CMP AL,'z'
  JA @@Write
  SUB AL,32
@@Write:
  STOSB
  CALL CharOut
  LOOP @@ReadLoop
  MOV AL,8
@@Is_Backspace:
  CMP DI,BX
  JBE @@ReadLoop
  DEC DI
  INC CX
  PUSH AX
  CALL CharOut
  MOV AL,32
  CALL CharOut
  POP AX
  CALL CharOut
  JMP @@ReadLoop
@@Is_Cr:
  CMP DI,BX
  JNA @@ReadLoop
  CALL CharOut
  MOV AL,10
  CALL CharOut
@@Terminate:
  SUB DI,BX
  MOV CX,DI
  MOV ES:[BX-1],CL
  RET 6
@@Is_Zero:
  CALL Readkey
  CMP AL,75
  MOV AL,8
  JE @@Is_Backspace
  JMP @@ReadLoop
Read_Line ENDP

Get_Jn PROC NEAR
PUBLIC Get_Jn
@@In_Loop:
  CALL Readkey
  OR AL,AL
  JNZ @@Not_Zero
  CALL Readkey
  JMP SHORT @@Error
@@Not_Zero:
  CMP AL,'j'
  JB @@CheckJN
  CMP AL,'n'
  JA @@Error
  SUB AL,32
@@CheckJN:
  CMP AL,'J'
  JE @@End_Input
  CMP AL,'N'
  JNE @@Error
@@End_Input:
  PUSH AX
  CALL CharOut
  MOV AL,13
  CALL CharOut
  MOV AL,10
  CALL CharOut
  POP AX
  RET
@@Error:
  MOV AL,7
  CALL CharOut
  JMP @@In_Loop
Get_Jn ENDP

Uninstall_Handler PROC NEAR
ASSUME DS:NOTHING
  MOV AH,35H
  INT 21H
  CMP BX,DI
  JNE @@Error
  MOV BX,ES
  CMP BX,CX
  JNE @@Error
  MOV AH,25H
  INT 21H
@@End_Proc:
  RET
@@Error:
  MOV AX,DATA
  MOV DS,AX
ASSUME DS:DATA
  OR [ErrorFlag],1
  RET
Uninstall_Handler ENDP

Get_PSPSeg PROC NEAR
  PUSH AX
  MOV AH,51H ;get current PSP segment
  XOR BX,BX
  INT 21H
  POP AX
  RET
Get_PSPSeg ENDP


DebugExec PROC NEAR
PUBLIC DebugExec
  Data_Prog EQU DWORD PTR [BP+6]
  Data_CmdLine EQU DWORD PTR [BP+2]
ASSUME DS:DATA
  CALL Init_TSRCheck
  MOV AX,3000H
  INT 21H
  CMP AL,3
  JB @@Ignore
  MOV CS:[Int24h_Strategy],Fail
@@Ignore:
  CALL Get_PSPSeg
  CMP BX,[PrefixSeg]
  JE @@PSPFuncOk
  MOV [DosError],0FFH
  JMP @@Terminate_1
@@PSPFuncOk:
  MOV [DosError],0
  MOV CX,CS
  MOV DS,CX
ASSUME DS:CODE
  MOV AX,3524H
  INT 21H
  MOV WORD PTR CS:[@@PrevInt24h],BX
  MOV WORD PTR CS:[@@PrevInt24h+2],ES
  MOV DX,OFFSET Int24h_Entry
  MOV AX,2524H
  INT 21H
  MOV [@@Save_BP],BP
  MOV [@@Save_SP],SP
  MOV [@@Save_SS],SS
  MOV WORD PTR [LdCmdLinePtr+2],CX
  MOV WORD PTR [LdFCB1Ptr+2],CX
  MOV WORD PTR [LdFCB2Ptr+2],CX
  MOV BP,SP
  LDS SI,Data_CmdLine
ASSUME DS:NOTHING
  MOV ES,CX ;code seg
  MOV DI,OFFSET PrgCmdLine
  MOV WORD PTR CS:[LdCmdLinePtr],DI
  CLD
  LODSB
  XOR CX,CX
  MOV CL,AL ;length byte
  MOV DX,CX
  STOSB
  REP MOVSB ;copy command line
  MOV AL,0DH ;cr
  STOSB
  SUB SI,DX
  MOV DI,OFFSET FCB1
  MOV WORD PTR CS:[LdFCB1Ptr],DI
  MOV AX,2901H
  INT 21H
  CBW
  MOV BYTE PTR CS:[@@Save_AX],AH
  MOV AH,20H
  MOV DI,OFFSET FCB2
  MOV WORD PTR CS:[LdFCB2Ptr],DI
@@Next_Byte:
  LODSB
  CMP AH,AL ;space/control char?
  JB @@Next_Byte
  MOV AX,2901H
  INT 21H
  CBW
  MOV BYTE PTR CS:[@@Save_AX+1],AH
  MOV DI,OFFSET Prog2Exec
  MOV DX,DI
  LDS SI,Data_Prog
  LODSB
  MOV CL,AL
  REP MOVSB
  PUSH CS
  POP DS
ASSUME DS:CODE
  MOV BX,OFFSET LoadPars
  MOV AX,4B01H
  INT 21H
@@Return_From_Prog:
  ASSUME DS:NOTHING
  CLI
  MOV BX,CS:[@@Save_SS]
  MOV SS,BX
  MOV SP,CS:[@@Save_SP]
  STI
  MOV BX,DATA
  MOV DS,BX
ASSUME DS:DATA
  JNC @@Cont
  MOV [DosError],AX
@@Cont:
  CALL Get_PSPSeg
  CMP BX,[PrefixSeg]
  JNE @@Start_Prog
  CMP [DosError],0
  JNE @@Terminate
  MOV AH,4DH
  INT 21H
  MOV [ExitCode],AL
@@Terminate:
  PUSH DS
  LDS DX,CS:@@PrevInt24h
ASSUME DS:NOTHING
  MOV AX,2524H
  INT 21H
  POP DS
ASSUME DS:DATA
  MOV BP,CS:[@@Save_BP]
@@Terminate_1:
  CALL End_TSRCheck
  RET 8
@@Start_Prog:
  CMP BX,CS:[LdSS] ;PSP=SS on start?
  JE @@Is_Com_File ;then .COM file
  MOV DI,OFFSET Stack_Test ;otherwise .EXE
  MOV AX,WORD PTR [DI+10H] ;initial SP from EXE-Header
  MOV CS:[LdSP],AX ;correct stack pointer
@@Is_Com_File:
  MOV ES,BX ;psp seg of child
  DEC BX
  ASSUME DS:NOTHING
  MOV DS,BX ;mcb of child's psp
  MOV AX,DS:[BlockSize]
  INC BX
  MOV DS,BX ;psp seg of child
  MOV CS:[Start_Progsize],AX
  MOV AX,CS:[@@Save_AX]
  MOV BX,CS:[LdSS]
  CLI
  MOV SS,BX
  MOV SP,CS:[LdSP]
  MOV DS:[0AH],OFFSET CS:@@Return_From_Prog
  MOV DS:[0CH],CS  ;essential for debugging
  STI
  JMP CS:[LdCSIP]
@@Save_SS DW 0
@@Save_SP DW 0
@@Save_BP DW 0
@@Save_AX DW 0
@@PrevInt24h DD 0
DebugExec ENDP

Div16 PROC NEAR
  REPT 4
    SHR CX,1
    RCR DX,1  ;resident paras
  ENDM
  RET
Div16 ENDP

End_TSRCheck PROC NEAR
ASSUME DS:DATA
  PUSH DS
  MOV CX,CS
  LDS DX,CS:PrevAddr33
ASSUME DS:NOTHING
  MOV DI,DS
  OR DI,DX
  JZ @@No_Mouse
  MOV AL,33H
  MOV DI,OFFSET Int33h_Entry
  CALL Uninstall_Handler
@@No_Mouse:
  MOV AL,21H
  MOV DI,OFFSET Int21h_Entry
  LDS DX,CS:PrevAddr21
  CALL Uninstall_Handler
  MOV AL,27H
  MOV DI,OFFSET Int27h_Entry
  LDS DX,CS:PrevAddr27
  CALL Uninstall_Handler
  POP DS
  RET
End_TSRCheck ENDP

Terminate_TSR PROC NEAR
ASSUME DS:DATA
  LES DI,Newint_Ptr
  XOR SI,SI
  MOV DS,SI  ;Nullpointer
ASSUME DS:NOTHING
  MOV CX,512
  CLD
  REP MOVSW  ;copy interrupt table
  MOV DS,BX
ASSUME DS:DATA
  LDS SI,Oldint_Ptr
ASSUME DS:NOTHING
  XOR DI,DI
  MOV ES,DI
  MOV CX,512
  MOV BX,CX
  MOV DX,SI
@@CMP_Loop:
  REPE CMPSW
  JE Finished
  SUB BX,CX
  DEC BX
  SHR BX,1  ;INTNo.
  MOV BYTE PTR CS:[Int_Changed+BX],TRUE
  SHL BX,1  ;2*IntNo.
  MOV CX,510
  SUB CX,BX
  SHL BX,1  ;4*IntNo
  MOV DI,BX
  MOV SI,DX
  ADD SI,BX ;offset of IntNo. in
            ;oldint_ptr^
  MOVSW  ;sorry for that, guys...
  MOVSW  ;...but interrupts are rather
         ;risky when only part
         ;of the TSR is inactive
  MOV BX,512
  JCXZ Finished
  JMP @@CMP_Loop
Finished:
  TEST CS:[Mouse],TRUE
  JZ @@No_Mouse
  XOR AX,AX
  STI
  INT 33H
@@No_Mouse:
  STI
  CALL Get_PSPSeg
  MOV AX,DATA
  MOV DS,AX
ASSUME DS:DATA
  MOV [TsrPSP_Seg],BX
  MOV ES,BX
  MOV AX,ES:[2CH] ;environment seg.
  MOV CS:[Env_Seg],AX
  DEC AX ;mcb seg of environment
  MOV ES,AX
  CMP BYTE PTR ES:[Flag],'M'
  JE @@Is_MCB
  CMP BYTE PTR ES:[Flag],'Z'
  JNE @@Env_Released
@@Is_MCB:
  CMP WORD PTR ES:[OwnerPSP],BX
  JNE @@Env_Released
  MOV DX,WORD PTR ES:[BlockSize]
  CALL Mul16
  JMP SHORT @@Write_Envsize
@@Env_Released:
  XOR DX,DX
  MOV CX,DX
@@Write_Envsize:
  MOV WORD PTR [Env_Memory],DX
  MOV WORD PTR [Env_Memory+2],CX
  CALL Get_UMB_Link_State
  CALL New_UMB_Link_State
  CALL Get_First_MCB_Seg
  JNC @@First_MCB_Found
  OR [ErrorFlag],2
  JMP SHORT @@End_Of_MCB_Chain
@@First_MCB_Found:
  MOV BX,[TsrPSP_Seg]
@@MCB_Loop:
  MOV ES,AX         ;next MCB
  INC AX
  CMP ES:[OwnerPSP],BX
  JNE @@IrRel_Memory
  CMP AX,ES:[OwnerPSP] ;PSP?
  JE @@IrRel_Memory
  CMP AX,CS:[Env_Seg] ;Environment?
  JE @@IrRel_Memory
  MOV DX,ES:[BlockSize]
  CALL Mul16
  ADD WORD PTR [Data_Memory],DX
  ADC WORD PTR [Data_Memory+2],CX
@@IrRel_Memory:
  MOV DH,ES:[Flag]
  CALL Test_MCBFlag
  JNC @@Tst_Z
  OR [ErrorFlag],4
  JMP SHORT @@End_Of_MCB_Chain
@@Tst_Z:
  JZ @@End_Of_MCB_Chain
  ADD AX,ES:[BlockSize]
  JMP @@MCB_Loop
@@End_Of_MCB_Chain:
  CALL Old_UMB_Link_State
  MOV AX,4C00H
  INT 21H
Terminate_TSR ENDP

Save_IntAdd PROC NEAR
  MOV AH,35H
  INT 21H
  MOV WORD PTR [DI],BX
  MOV WORD PTR [DI+2],ES
  RET
Save_IntAdd ENDP

Init_TSRCheck PROC NEAR
  PUSH DS
  PUSH CS
  POP DS
ASSUME DS:CODE
  MOV AL,33H
  MOV DI,OFFSET PrevAddr33
  CALL Save_IntAdd
  MOV AX,ES
  OR  AX,BX
  PUSHF
  MOV AL,27H
  MOV DI,OFFSET PrevAddr27
  CALL Save_IntAdd
  MOV AL,21H
  MOV DI,OFFSET PrevAddr21
  CALL Save_IntAdd
  POPF
  JZ @@No_Mouse
  MOV AX,2533H
  MOV DX,OFFSET Int33h_Entry
  INT 21H
@@No_Mouse:
  MOV AX,2527H
  MOV DX,OFFSET Int27h_Entry
  INT 21H
  MOV AL,21H
  MOV DX,OFFSET Int21h_Entry
  INT 21H
  POP BX ;data seg
  MOV DS,BX
ASSUME DS:DATA
  LES DI,Oldint_Ptr
  XOR SI,SI
  MOV DS,SI
ASSUME DS:NOTHING
  MOV CX,512
  CLD          ;copy interrupt vector
  REP MOVSW    ;table to oldint_ptr^
  MOV DS,BX
  RET
Init_TSRCheck ENDP

Set_EXE_Data PROC NEAR
PUBLIC Set_EXE_Data
ASSUME DS:DATA
  LES DI,[FBlock]
  MOV SI,OFFSET EXE_Init
  ADD SI,100H
  SUB SI,OFFSET Start_TSRProg
  PUSH DS
  PUSH CS
  POP DS
ASSUME DS:CODE
  MOV AX,ES:[DI+10H] ;initial sp
  MOV WORD PTR [Old_Stack],AX
  MOV AX,ES:[DI+0EH] ;initial ss
  MOV WORD PTR [Old_Stack+2],AX
  MOV AX,ES:[DI+14H] ;initial ip
  MOV WORD PTR [Old_Entrypoint],AX
  MOV ES:[DI+14H],SI ;new init. ip
  MOV AX,ES:[DI+16H] ;initial cs
  MOV WORD PTR [Old_Entrypoint+2],AX
  MOV AX,ES:[DI+4] ;number of pages
  MOV [Old_Number_Of_Pages],AX
  MOV BX,ES:[DI+2] ;bytes last page
  MOV [Old_Last_Page],BX
  MOV AH,AL
  XOR AL,AL
  SHL AX,1  ;ax*512
  OR BX,BX
  JZ @@Full_Pages_Only
  SUB AX,512
  ADD AX,BX
@@Full_Pages_Only:
  POP DS
ASSUME DS:DATA
  CMP AX,WORD PTR [FSize]
  JNE @@Error
  MOV DX,ES:[DI+8] ;header paras
  CALL Mul16
  SUB AX,DX        ;old filesize (memory)
  ADD AX,OFFSET EXE_Init
  SUB AX,OFFSET EXE_Data ;+data space
  SUB AX,SI        ;-ip to start with
  JNB @@Big_Enough
  MOV DX,AX
  NEG DX
  XOR AX,AX
  JMP SHORT @@Write_Results
@@Big_Enough:
  MOV DX,0F10H
  AND DH,AL
  SUB DL,DH
  XOR DH,DH
  ADD AX,DX
  MOV CL,4
  SHR AX,CL ;rel.segment start
@@Write_Results:
  MOV [Front_Buf_Bytes],DX
  MOV ES:[DI+0EH],AX ;rel. ss
  MOV ES:[DI+16H],AX ;rel. cs
  MOV AL,TRUE
  RET
@@Error:
  XOR AX,AX
  RET
Set_EXE_Data ENDP

ChkConverted_Already PROC NEAR
PUBLIC ChkConverted_Already
ASSUME DS:DATA
  MOV BX,DS
  LES DI,FBlock
  TEST [Is_Exe],TRUE
  MOV AX,CS
  MOV DS,AX
ASSUME DS:CODE
  CLD
  JNZ @@EXE_File
  MOV SI,OFFSET Start_TSRProg
  MOV CX,OFFSET Patch_0+1
  SUB CX,SI
  REPE CMPSB
  JE @@Test_Writeback
@@Not_Found:
  XOR AX,AX
@@End_Proc:
  MOV DS,BX
ASSUME DS:DATA
  RET
@@Test_Writeback:
ASSUME DS:CODE
  PUSH DS
  MOV DS,BX
ASSUME DS:DATA
  MOV DI,WORD PTR [FBlock]
  ADD DI,WORD PTR [FSize]
  CALL Get_Writeback_Space
  SUB DI,AX
  MOV CX,AX
  POP DS
ASSUME DS:CODE
  MOV SI,OFFSET Writeback
  REPE CMPSB
  JNE @@Not_Found
@@Found:
  MOV AL,TRUE
  JMP @@End_Proc
@@EXE_File:
  MOV DX,ES:[DI+8] ;header paras
  CALL Mul16
  MOV SI,DI
  ADD DI,DX  ;start program
  MOV DX,ES:[SI+16H] ;initial rel. cs
  CALL Mul16
  ADD DX,ES:[SI+14H] ;offset entry point
  ADD DI,DX
  MOV AX,OFFSET Start_TSRProg
  PUSH DI
  MOV SI,AX
  SUB AX,OFFSET EXE_Init
  ADD DI,AX
  MOV CX,OFFSET Patch_0+1
  SUB CX,SI
  REPE CMPSB
  POP SI
  JNE @@Not_Found
  PUSH ES
  POP DS
ASSUME DS:NOTHING
  PUSH CS
  POP ES
  MOV DI,OFFSET EXE_Data
  MOV CX,OFFSET EXE_Init
  SUB CX,DI
  SUB SI,CX
  REP MOVSB  ;get old exe data
  JMP @@Found
ChkConverted_Already ENDP

Restore_EXE PROC NEAR
PUBLIC Restore_EXE
ASSUME DS:DATA
  LES DI,FBlock
  PUSH DS
  PUSH CS
  POP DS
ASSUME DS:CODE
  MOV AX,WORD PTR [Old_Stack+2]
  MOV ES:[DI+0EH],AX ;old ss
  MOV AX,WORD PTR [Old_Stack]
  MOV ES:[DI+10H],AX ;old sp
  MOV AX,WORD PTR [Old_Entrypoint]
  MOV ES:[DI+14H],AX ;old ip
  MOV AX,WORD PTR [Old_Entrypoint+2]
  MOV ES:[DI+16H],AX ;old cs
  MOV AX,[Old_Last_Page]
  MOV ES:[DI+2],AX ;bytes last page
  MOV DX,[Old_Number_Of_Pages]
  MOV ES:[DI+4],DX ;number of pages
  MOV DH,DL
  XOR DL,DL
  SHL DX,1
  OR AX,AX
  JZ @@Ok
  SUB DX,512
@@Ok:
  ADD AX,DX
  XOR DX,DX
  POP DS
  RET
Restore_EXE ENDP

Adjust_Checksum PROC NEAR
PUBLIC Adjust_Checksum
ASSUME DS:DATA
  CLD
  PUSH DS
  MOV CX,WORD PTR [FSize]
  MOV DI,CX
  DEC DI
  DEC DI
  SHR CX,1
  LDS SI,FBlock
  XOR DX,DX
ASSUME DS:NOTHING
@@Read_Loop:
  LODSW
  ADD DX,AX
  LOOP @@Read_Loop
  NOT DX
  MOV [DI],DX
  POP DS
ASSUME DS:DATA
  RET
Adjust_Checksum ENDP

Patch PROC NEAR
PUBLIC Patch
ASSUME DS:DATA
  PUSH DS
  PUSH BP
  CLD
  CMP [Free_Env],TRUE
  JE @@Call_Release_Env
  MOV CX,OFFSET CS:Patch_21
  MOV DI,OFFSET CS:Patch_20
  SUB CX,DI
  PUSH CS
  POP ES
  MOV AL,90H ;nop
  REP STOSB
@@Call_Release_Env:
  MOV BP,SP
  SUB SP,4
  MOV DX,WORD PTR [Program_Memory]
  MOV CX,WORD PTR [Program_Memory+2]
  CALL Div16
  MOV WORD PTR CS:[Patch_18+2],DX
  MOV WORD PTR CS:[Patch_23+1],DX
  MOV WORD PTR CS:[Patch_31+4],DX
  XOR DX,DX
  MOV CX,DX
  CMP [No_Uninstall],TRUE
  JNE @@Tst_JNChar
  MOV AX,'RF'
  MOV WORD PTR CS:[Patch_14+5],AX
  MOV WORD PTR CS:[Patch_22+1],AX
@@Tst_JNChar:
  CMP [JNChar],'J'
  JE @@Check_Installation
  MOV BYTE PTR CS:[Patch_3],0EBH ;jmp short
@@Check_Installation:
  MOV DL,BYTE PTR [PrgName]
  MOV CL,[Number_Of_Vecs]
  MOV BYTE PTR CS:[Patch_16+3],CL
  MOV AX,CX
  SHL CX,1  ;2*number_of_vecs
  ADD AX,CX ;3*number_of_vecs
  SHL CX,1  ;4*number_of_vecs
  ADD AX,CX ;7*number_of_vecs
  ADD AX,DX ;7*number_of_vecs+length(prgname)
  ADD AX,21 ;number_of_vecs+length byte+'RF'+blocksize+extra 15 Byte=21
  MOV CL,4
  SHR AX,CL ;number of paragraphs
  MOV WORD PTR CS:[Patch_17+2],AX
  MOV WORD PTR CS:[Patch_21+1],AX
  MOV BX,100H
  MOV SI,OFFSET CS:ProgName
  SUB SI,OFFSET CS:Start_TSRProg
  ADD SI,BX  ;ofs(progname) (runtime)
  MOV DI,SI
  ADD DI,DX
  INC DI
  MOV DL,BYTE PTR [Cmdline]
  ADD DX,DI
  INC DX     ;ofs(intvec #) (runtime)
  MOV CX,[ChkTSR_Space]
  MOV CS:[Save_ChkTSR_Space],CX
  MOV AX,WORD PTR [FSize]
  MOV CS:[Save_FSize],AX
  CMP [Is_Exe],TRUE
  JNE @@Is_Com
  MOV [BP-2],AX ;dummy
  MOV [BP-4],AX ;dummy
  SUB CX,[Front_Buf_Bytes]
  SUB CX,OFFSET Start_TSRProg
  ADD CX,OFFSET EXE_Data+0F2H
  PUSH DI
  LES DI,FBlock
  MOV ES:[DI+10H],CX ;init. SP
  MOV AX,ES:[DI+0AH] ;min. heap
  CMP AX,ES:[DI+0CH] ;max. heap
  JE @@Reduced_Heap
  MOV AX,0FFFFH
  JMP SHORT @@Set_Max_BlkSize
@@Reduced_Heap:
  MOV AX,CS:[Start_Progsize]
@@Set_Max_BlkSize:
  MOV WORD PTR CS:[EXEPatch_4+1],AX
  SUB CX,302H
  POP DI
  JMP SHORT @@EXE_Cont
@@Is_Com:
  CMP AX,CX
  JB @@FSize_Smaller
  XCHG AX,CX
@@FSize_Smaller:
  MOV [BP-4],AX
  ADD CX,BX
  MOV WORD PTR CS:[Patch_6+1],CX
  ADD CX,AX
  MOV [BP-2],CX
  SUB CX,BX
  CALL Get_Writeback_Space
  ADD CX,AX
@@EXE_Cont:
  PUSH CS
ASSUME DS:CODE
  POP DS
  SUB BX,OFFSET Start_TSRProg
  MOV BYTE PTR [Orig_UMB_Link_State],8
  ADD WORD PTR [Patch_0+1],BX
  ADD WORD PTR [Patch_1+1],CX
  ADD WORD PTR [Patch_2+1],BX
  ADD WORD PTR [Patch_4+1],BX
  MOV AX,[BP-4]
  MOV WORD PTR [Patch_5+1],AX
  MOV AX,[BP-2]
  MOV WORD PTR [Patch_7+1],AX
  ADD WORD PTR [Patch_8+1],BX
  ADD WORD PTR [Patch_9+1],BX
  CMP CS:[Mouse],TRUE
  JE @@Cont
  MOV WORD PTR [Patch_10],9090H ;2*nop
@@Cont:
  ADD WORD PTR [Patch_11+4],BX
  ADD WORD PTR [Patch_12+1],CX
  ADD WORD PTR [Patch_13+1],BX
  MOV WORD PTR [Patch_15+1],SI
  MOV WORD PTR [Patch_19+1],DI
  MOV WORD PTR [Patch_24+1],SI
  MOV WORD PTR [Patch_25+1],DX
  ADD WORD PTR [Patch_26+1],BX
  ADD WORD PTR [Patch_27+1],BX
  ADD WORD PTR [Patch_28+2],BX
  ADD WORD PTR [Patch_29+1],BX
  ADD WORD PTR [Patch_30+2],BX
  ADD SP,4
  POP BP
  POP DS
ASSUME DS:DATA
  CMP [Is_Exe],TRUE
  JE @@EXE_Patch
  PUSH CS
  POP  ES
  MOV CX,OFFSET ComPatch_End
  MOV DI,OFFSET ComPatch_Start
  SUB CX,DI
  MOV AL,90H
  REP STOSB
  RET
@@EXE_Patch:
  PUSH DS
  PUSH CS
  POP DS
ASSUME DS:CODE
  ADD WORD PTR [EXEPatch_1+2],BX
  ADD WORD PTR [EXEPatch_2+2],BX
  ADD WORD PTR [EXEPatch_3+3],BX
  ADD WORD PTR [EXEPatch_5+3],BX
  ADD WORD PTR [EXEPatch_6+3],BX
  ADD WORD PTR [EXEPatch_7+3],BX
  ADD WORD PTR [EXEPatch_8+2],BX
  ADD WORD PTR [EXEPatch_9+3],BX
  POP DS
ASSUME DS:DATA
  RET
Patch ENDP

ASSUME DS:CODE
Writeback:
  CLD
  JNC @@No_Bytes
  MOVSB
@@No_Bytes:
  REP MOVSW
  POP DI
  JMP DI
End_Writeback:

ASSUME DS:NOTHING
;*** START OF CODE TO BE COPIED TO .EXE FILES ***
EXE_Data:
  Old_Stack DD 0
  Old_Entrypoint DD 0
  Old_Last_Page DW 0
  Old_Number_Of_Pages DW 0
  Old_BlockSize DW 0FFFFH
  Exe_AXSave DW 0

EXE_Init PROC NEAR
EXEPatch_1:
  MOV CS:[Exe_AXSave],AX
  MOV AX,ES ;psp seg
  DEC AX
  MOV DS,AX ;mcb of psp
  MOV AX,DS:[BlockSize]
EXEPatch_2:
  MOV CS:[Old_BlockSize],AX
  MOV AH,4AH
  MOV BX,0FFFFH
  INT 21H
  JNC @@Error
  CMP AX,8
  JNE @@Error
  MOV AH,4AH
  INT 21H
  JC @@Error
  PUSH CS
  POP DS
  JMP SHORT Start_TSRProg
@@Error:
  JMP Patch_26 ;memory allocation error
EXE_Init ENDP

Exe_DeInit PROC NEAR
  MOV AX,ES ;psp seg
  DEC AX
  MOV DS,AX ;mcb of psp
EXEPatch_3:
  MOV BX,CS:[Old_BlockSize]
  MOV AX,DS:[BlockSize]
  CMP AX,BX
  JBE @@Blocksize_Ok
  MOV AH,4AH
  INT 21H
  MOV AX,BX
@@Blocksize_Ok:
EXEPatch_4:
  MOV BX,100H  ;initial paras
  CMP AX,BX
  JB @@AX_Smaller
  MOV AX,BX
@@AX_Smaller:
  MOV BX,ES
  ADD AX,BX
  MOV ES:[PSPNextParagraph],AX
@@Call_Exe:
  MOV CX,ES
  MOV DS,CX
  ADD CX,10H ;start of prog
EXEPatch_5:
  MOV DX,WORD PTR CS:[Old_Stack]
EXEPatch_6:
  MOV BX,WORD PTR CS:[Old_Stack+2]
  ADD BX,CX
EXEPatch_7:
  ADD WORD PTR CS:[Old_Entrypoint+2],CX
EXEPatch_8:
  MOV AX,WORD PTR CS:[Exe_AXSave]
  CLI
  MOV SS,BX
  MOV SP,DX
  STI
EXEPatch_9:
  JMP CS:[Old_Entrypoint]
@@Error:
  JMP Patch_26 ;memory allocation error
Exe_DeInit ENDP

ASSUME DS:CODE,ES:NOTHING

; *** START OF CODE FOR .COM FILES ***

Start_TSRProg PROC NEAR
  JMP @@Cont
            DB 8,8,8,'TSR',26
UnInstall_Message DB 'TSR uninstalled.$'
DosVer_Err DB 7,'DOS 3.0 or higher '
           DB 'required.$'
Out_Of_Stack  DB 7,'Out of stack space.$'
Inst_Already DB 7,'Program already '
             DB 'resident.$'
Ints_Not_Found DB 7,'Cannot '
               DB 'uninstall TSR.$'
Not_Installed DB 7,'Program not resident.$'
MemErr_Msg  DB 7,'MCB not found.$'
MemErr_2   DB 7,'Memory allocation error.$'
@@Cont:
  MOV DS:[AXSave],AX  ;ax may contain
                    ;information
  MOV AX,3000H
  INT 21H
  CMP AL,3
  JNB @@Dos_Version_Ok
Patch_0:
  MOV DX,OFFSET DosVer_Err
  CALL Display_ExitMessage
  XOR BX,BX
  PUSH ES
  PUSH BX
  RETF    ;int 20h
Err_Exit:
  MOV AL,01
  JMP SHORT @@Terminate_Prog
Norm_Exit:
  XOR AL,AL
@@Terminate_Prog:
  CALL Display_ExitMessage
  MOV AH,4CH
  INT 21H

Save_FSize  DW 0
Save_ChkTSR_Space DW 0
Orig_UMB_Link_State DB 8
@@Dos_Version_Ok:
Patch_1:
  MOV AX,300H ;psp+file+200h
  CMP SP,AX
Patch_2:
  MOV DX,OFFSET Out_Of_Stack
  JB Err_Exit
  MOV BP,SP
  MOV SP,AX
  PUSH BP    ;old sp
  MOV BP,SP
  CALL CBreak_Off
  CALL Get_UMB_Link_State
  CALL Check_Mem
  CALL Check_Commandline
  JZ @@Uninstall
  OR AX,AX
Patch_3:
  JZ @@Install_Ok
Patch_4:
  MOV DX,OFFSET Inst_Already
  JMP Err_Exit
@@Install_Ok:
  CALL Install
  CALL Old_CBreak
ComPatch_Start:
  JMP Exe_DeInit
ComPatch_End:
  POP BP
  MOV SP,BP
  POP AX
  XOR AX,AX
  PUSH AX ;zero word on stack top
  MOV AX,WORD PTR DS:[AXSave]
Patch_5:
  MOV CX,0 ;bytes to be copied
Patch_6:
  MOV SI,0 ;ofs first byte to be copied
  SHR CX,1
  MOV DI,100H
  PUSH DI
Patch_7:
  MOV BX,0 ;ofs copy routine
  JMP BX
@@Error:
Patch_8:
  MOV DX,OFFSET Ints_Not_Found
  JMP Err_Exit
@@Uninstall:
  OR AX,AX
  JNZ @@Uninstall_Ok
Patch_9:
  MOV DX,OFFSET Not_Installed
  JMP Err_Exit
@@Uninstall_Ok:
  OR DL,DL ;ints found?
  JZ @@Error
  PUSH ES
  PUSH AX
  XOR DI,DI
  MOV ES,DI
  MOV BX,DI
  MOV AX,4B02H   ;detect task switcher
  INT 2FH
  MOV BX,ES
  OR BX,DI       ;if task switcher present
  JNZ @@Error    ;don't uninstall
  POP DS         ;info seg
  ASSUME DS:NOTHING
  MOV DX,CX  ;psp seg
  MOV BX,6
  MOV CH,BH
  ADD BL,BYTE PTR DS:[4] ;length progname
  MOV SI,BX ;pointer to first intno.
  MOV CL,BYTE PTR [SI-1]
  JCXZ @@Ints_Ok
  XOR AX,AX
  MOV ES,AX
  CLD
  CLI
@@WriteInts:
  XOR AH,AH
  LODSB
  SHL AX,1
  SHL AX,1
  MOV DI,AX
  MOVSW     ;unhook TSR vectors
  MOVSW
  ADD SI,2
  LOOP @@WriteInts
@@Ints_Ok:
  XOR AX,AX
  MOV DS:[Flag],AH ;overwrite signature
  STI
Patch_10:
  INT 33H   ;reset mouse
            ;TSR should be dead code now
  MOV DS,DX ;PSP seg
  CMP WORD PTR DS:[0],20CDH ;int 20h
  JNE @@TSR_PSP_Corrupted
  CMP WORD PTR DS:[50H],21CDH ;int 21h
  JNE @@TSR_PSP_Corrupted
  CMP BYTE PTR DS:[52H],0CBH   ;retf
  JNE @@TSR_PSP_Corrupted
  POP WORD PTR DS:[16H] ;seg parent process
Patch_11:
  MOV WORD PTR DS:[0AH],OFFSET CS:@@Return_From_TSR
  MOV WORD PTR DS:[0CH],CS
  MOV BX,DS
  MOV AH,50H ;set psp
  INT 21H
  MOV AX,4C00H
  INT 21H
@@Return_From_TSR:
  CLI
  MOV AX,CS
  MOV SS,AX
Patch_12:
  MOV SP,300H
  STI
Patch_13:
  MOV DX,OFFSET UnInstall_Message
  JMP Norm_Exit
@@TSR_PSP_Corrupted:
  CALL Release_All_Mem
  JMP Patch_13
Start_TSRProg ENDP

Owner_Of_This_Block EQU WORD PTR [BP-2]
TsrPSPSeg           EQU WORD PTR [BP-4]
InfoDataSeg         EQU WORD PTR [BP-6]
Current_PSP_Seg     EQU WORD PTR [BP-8]

Check_InfoSeg_Validity PROC NEAR
  PUSH AX
  PUSH BX
  PUSH DX
  PUSH DS
  MOV BX,[Owner_Of_This_Block]
  MOV SI,BX
  DEC BX
  MOV ES,BX ;MCB of owner seg
  CMP SI,ES:[OwnerPSP] ;psp?
  JNE @@Free_DataSeg
  CMP WORD PTR ES:[BlockSize],CX  ;correct prog size?
  JNE @@Free_DataSeg
  CMP SI,[Current_PSP_Seg]
  JE @@Free_DataSeg
  MOV DH,ES:[Flag]
  CALL Test_MCBFlag
  JNC @@PSP_Found
@@Free_DataSeg:
  POP DS
  POP DX
  CALL Test_MCBFlag
  JC @@Illegal_Seg
  MOV ES,AX
  MOV BYTE PTR ES:[Flag],0
  MOV AH,49H
  INT 21H
@@Illegal_Seg:
  ADD SP,4
  CALL Get_First_MCB_Seg ;not elegant
                         ;but safe+short
  XOR BX,BX
  MOV DL,BL
  RET
@@Err:
  POP BP
  POP DX
  POP CX
  POP DS
  POP DX
  POP BX
  POP AX
  XOR DL,DL
  RET
@@PSP_Found:
  MOV [TsrPSPSeg],SI
  MOV [InfoDataSeg],AX
  MOV DX,SI
  MOV DS,AX
  MOV SI,DI
  XOR CX,CX
  LODSB ;number of ints
  MOV CL,AL
  JCXZ @@Ints_Ok
@@ReadInts:
  MOV AH,35H
  LODSB
  INT 21H
  ADD SI,4 ;pointer to ofs of new int
  PUSH CX
  PUSH DX
  PUSH BP
  CALL Mul16
  LODSW    ;offset of TSR handler
  ADD DX,AX ;expected linear address...
  ADC CX,0  ;..in cx:dx
  MOV DI,DX
  MOV BP,CX ;...or bp:di
  MOV DX,ES
  CALL Mul16
  ADD DX,BX ;address found in...
  ADC CX,0  ;...cx:dx
  CMP DI,DX
  JNE @@Err
  CMP BP,CX
  JNE @@Err
  POP BP
  POP DX
  POP CX
  MOV ES,DX
  MOV DI,AX ;es:di --> ISR
  CMP WORD PTR ES:[DI+6],424BH ;IBM standard TSR signature
  JNE @@Read_Loop
  CMP WORD PTR ES:[DI],10EBH ;jmp $+16
  JNE @@Read_Loop
  CMP BYTE PTR ES:[DI+9],0EBH ;jmp short
  JNE @@Read_Loop
  MOV AX,ES:[DI+2] ;offset prevaddr ISR
  MOV [SI-6],AX ;copy to our data seg
  MOV AX,ES:[DI+4]
  MOV [SI-4],AX
@@Read_Loop:
  LOOP @@ReadInts
@@Ints_Ok:
  POP DS
  POP DX
  POP BX
  POP AX
  MOV DL,1
  RET
Check_InfoSeg_Validity ENDP

ASSUME DS:CODE
Check_Mem PROC NEAR
;returns: ax:segment info data
;         cx:PSPSeg of TSR
;         dl:1=ints still point to tsr
;            0=ints changed by other prog
;or:      ax=cx=dl=0 (TSR not found)
  PUSH BP
  MOV BP,SP
  XOR DX,DX
  PUSH DX  ;owner psp
  PUSH DX  ;tsrpspseg
  PUSH DX  ;infodataseg
  PUSH ES  ;current_psp_seg
  CLD
  CALL New_UMB_Link_State
  CALL Get_First_MCB_Seg
  JC @@Terminate_Proc
@@MCB_Loop:
  MOV ES,AX
  INC AX
  MOV CX,ES:[OwnerPSP]
  MOV [Owner_Of_This_Block],CX
  MOV BX,ES:[BlockSize]
  MOV DH,ES:[Flag]
  CMP CX,40H  ;DOS data or free seg?
  JBE @@Next_MCB
  MOV ES,AX ;data segment
Patch_14:
  CMP WORD PTR ES:[Flag],'FR'
  JNE @@Next_MCB
  MOV DI,4
Patch_15:
  MOV SI,OFFSET ProgName
  XOR CH,CH
  MOV CL,[SI]
  INC CX
  REPE CMPSB
  JNE @@Next_MCB
Patch_16:
  CMP BYTE PTR ES:[DI],0 ;number of ints
  JNE @@Next_MCB
Patch_17:
  CMP BX,100H ;correct data size?
  JNE @@Next_MCB
  MOV CX,ES:[2] ;prog size
Patch_18:
  CMP CX,100H ;expected prog size?
  JNE @@Next_MCB
  CALL Test_MCBFlag ;found it!
  JC @@Err
  CALL Check_InfoSeg_Validity
  OR DL,DL  ;removable?
  JZ @@Next_MCB ;look for next if not
@@Terminate_Proc:
  CALL Old_UMB_Link_State
  POP ES
  POP AX
  POP CX
  POP BP ;dummy
  POP BP
  RET
@@Next_MCB:
  CALL Test_MCBFlag
  JC @@Err
  JZ @@Terminate_Proc
  ADD AX,BX ;address of next mcb
  JMP @@MCB_Loop
@@Err:
  JMP Err_Exit
Check_Mem ENDP

Check_Commandline PROC NEAR
;return: zero flag set:   unload program
;        zero flag clear: load program
  PUSH DS
  PUSH ES
  PUSH AX
  PUSH CX
  CLD
  MOV DI,81H ;first byte of command line
  MOV CL,ES:[DI-1] ;length(commandline)
  XOR CH,CH
  JCXZ @@No_Param
  MOV AL,32 ;space
  REPE SCASB
  JE @@No_Param
  INC CX
  DEC DI
Patch_19:
  MOV SI,100H ;ofs uninstallparam
  CMP CL,[SI]
  JB @@No_Param
  MOV CL,[SI]
  INC SI
  XCHG DI,SI
  PUSH DS
  PUSH ES
  POP DS
  POP ES
@@CLoop:
  LODSB
  CMP AL,'a'
  JB @@Cont
  CMP AL,'z'
  JA @@Cont
  SUB AL,32 ;convert to uppercase
@@Cont:
  SCASB
  LOOPE @@CLoop
  JMP SHORT @@Exit
@@No_Param:
  AND DI,DI ;no zero flag
@@Exit:
  POP CX
  POP AX
  POP ES
  POP DS
  RET
Check_Commandline ENDP

Release_Env PROC NEAR
  PUSH ES
  MOV AX,ES:[2CH]
  MOV ES,AX ;environment segment
  MOV AH,49H
  INT 21H ;release block
  POP ES
  RET
Release_Env ENDP

Install PROC NEAR
  PUSH ES
Patch_20:
  CALL Release_Env
Patch_21:
  MOV DX,0FFFFH ;number of paragraphs
  MOV BX,DX
  MOV AH,48H ;allocate memory
  INT 21H
  JNC @@Block_Reserved
  CMP AL,8
  JNE @@Error
  MOV BX,0FFFFH
  MOV AH,4AH    ;get max. blocksize
  INT 21H
  JNC @@Error
  CMP AL,8
  JNE @@Error
  DEC BX ;we need another block for a mcb
  SUB BX,DX ;and our data block
  JB @@Error
  MOV AX,BP
  ADD AX,19 ;4 byte on stack+15
  MOV CL,4
  SHR AX,CL ;number of paras for our program
  CMP BX,AX
  JB @@Error
  MOV AH,4AH ;shrink program block
  INT 21H
  JC @@Error
  CALL Adjust_PSPNextPara
  XCHG DX,BX
  DEC DX     ;unused para on stack top
  CALL Mul16 ;byte program
  OR CX,CX   ;>64K?
  JNZ @@Stack_Ok
  CMP DX,[BP] ;old sp
  JA @@Stack_Ok
  MOV [BP],DX ;reduce size of stack
@@Stack_Ok:
  MOV AH,48H
  INT 21H
  JC @@Error
@@Block_Reserved:
  MOV ES,AX ;segment of allocated block
  MOV DX,AX
  XOR CX,CX
  MOV DI,CX
Patch_22:
  MOV AX,'FR'
  CLD
  STOSW
Patch_23:
  MOV AX,100H ;resident paras
  STOSW
Patch_24:
  MOV SI,OFFSET ProgName
  LODSB
  MOV CL,AL
  STOSB
  REP MOVSB
Patch_25:
  MOV SI,0 ;ofs intvec no.
  LODSB
  MOV CL,AL ;count of ints.
  STOSB
  JCXZ @@End_Loop
@@Read_Ints:
  LODSB     ;next int no.
  STOSB
  MOV AH,35H
  INT 21H
  PUSH ES
  MOV ES,DX
  MOV AX,BX
  STOSW ;ofs old intvec
  POP AX
  STOSW ;seg old intvec
  MOVSW ;offset new intvec
  LOOP @@Read_Ints
@@End_Loop:
  POP ES
  CALL Check_ProgMemSize
  RET
@@Error:
Patch_26:
  MOV DX,OFFSET MemErr_2
  JMP Err_Exit
Install ENDP

Release_All_Mem PROC NEAR
;dx must point to the psp of the
;program to be removed
  PUSH CS
  POP DS
ASSUME DS:CODE
  CALL New_UMB_Link_State
  MOV SI,DX
  MOV ES,DX
  MOV AH,49H
  INT 21H
  JC @@Error
  CALL Get_First_MCB_Seg
  MOV CX,AX
@@MCB_Loop:
  MOV ES,AX
  INC AX
  MOV DH,ES:[Flag]
  MOV DI,ES:[OwnerPSP]
  CMP DI,SI
  JE @@Kill_Block
  OR DI,DI
  JZ @@Keep_Old_Seg
  MOV CX,ES
@@Keep_Old_Seg:
  ADD AX,ES:[BlockSize]
  CALL Test_MCBFlag
  JC @@Err
  JNZ @@MCB_Loop
  CALL Old_UMB_Link_State
  RET
@@Kill_Block:
  CALL Test_MCBFlag
  JC @@Err
  MOV ES,AX
  MOV AH,49H
  INT 21H
  JC @@Error
  MOV AX,CX
  JMP @@MCB_Loop
@@Error:
  XOR DH,DH
  CALL Test_MCBFlag
@@Err:
  JMP Err_Exit
Release_All_Mem ENDP

Adjust_PSPNextPara PROC NEAR
  PUSH BX
  MOV BX,ES
  MOV AX,BX          ;PSP seg
  DEC BX             ;MCB of PSP
  MOV ES,BX
  CMP BYTE PTR ES:[Flag],'M'
  JNE @@Do_Not_Change
  MOV BX,ES:[BlockSize]
  ADD BX,AX          ;Seg of next MCB
  MOV ES,AX          ;PSP seg
  MOV ES:[PSPNextParagraph],BX
@@Do_Not_Change:
  POP BX
  RET
Adjust_PSPNextPara ENDP

INCLUDE TSRINC.INC

Check_ProgMemSize PROC NEAR
  PUSH DS
  MOV AX,ES
  DEC AX  ;MCB of PSP
  MOV DS,AX
Patch_31:
  CMP DS:[BlockSize],100H
  POP DS
  JAE @@Ok
  JMP Patch_26 ;memory allocation error
@@Ok:
  RET
Check_ProgMemSize ENDP

ProgName:
CODE ENDS
END
