PROGRAM ShowInts;

{**************************************
*        Autor : Robert Flogaus       *
*       Sprache: Turbo Pascal 7.0     *
*   bersetzung: tpc showints /DSCRN  *
*                /DKEYBD /B           *
*   Zweck:       Demo-TSR             *
*                (Anzeige verbogener  *
*                Interrupt-Vektoren)  *
*                Anmerkung: /DDOS     *
*                kostet nur Speicher! *
***************************************}


{$M 1024,0,0}
{$B-,S-,R-,Q-,I-}

USES {$IFDEF CRT}Crt,{$ENDIF}PopUp;

TYPE
  VectorArray=ARRAY[0..255] OF LONGINT;
  String5=STRING[5];

CONST
  Copyright:STRING[50]=#13#10'SHOWINTS 1.0, (C) '+
            'R.Flogaus'+
            '+tewi Verlag 1993'#13#10#13#10;

VAR
  OldPtrs:VectorArray;
  NewPtrs:^VectorArray;
  st:String5;

PROCEDURE Hex(num:WORD);

{wandelt Word-Variable in Hexstring}

VAR
  rest,i:BYTE;

BEGIN
  st:='';
  WHILE num<>0 DO BEGIN
    rest:=num AND 15;
    num:=num SHR 4;
    IF Length(st)<(SizeOf(st)-1) THEN BEGIN
      Move(st[1],st[2],Length(st));
      Inc(st[0]);
      IF rest<10 THEN
        st[1]:=Chr(rest+48)
      ELSE
        st[1]:=Chr(rest+55)
    END
  END;
  rest:=Length(st);
  IF rest<4 THEN BEGIN
    st[0]:=#4;
    Move(st[1],st[5-rest],rest);
    FOR i:=1 TO 4-rest DO st[i]:='0'
  END;
  IF Length(st)<(SizeOf(st)-1) THEN BEGIN
    Inc(st[0]);
    st[Length(st)]:='h'
  END
END;

PROCEDURE Print_Pointer(temp:LONGINT);

BEGIN
  Hex(temp SHR 16);
  StrgWrite(st);
  StrgWrite(':');
  Hex(temp AND $FFFF);
  StrgWrite(st);
END;

PROCEDURE Print_Results;

VAR
  temp:LONGINT;
  i:BYTE;
  Difference_Found:BOOLEAN;

BEGIN
  Difference_Found:=FALSE;
  StrgWrite(Copyright);
  FOR i:=0 TO 255 DO
    IF (NewPtrs^[i]<>OldPtrs[i]) AND (i<>$22)
    {Rcksprungadresse INT 22h immer anders}
    {$IFDEF DOS}
    {mit DOS ist's umstndlicher...}
    AND ((i<>$23) AND (i<>$24) AND (i<>$1B))
    OR  ((i=$23) AND (OldPtrs[i]<>LONGINT(Prog_Vec_23h)))
    OR  ((i=$24) AND (OldPtrs[i]<>LONGINT(Prog_Vec_24h)))
    OR  ((i=$1B) AND (OldPtrs[i]<>LONGINT(Prog_Vec_1bh)))
    {...weil das TSR selbst Interrupts verbiegt!}
    {$ENDIF}
    THEN BEGIN
      StrgWrite('Interrupt ');
      Hex(i);
      StrgWrite(st);
      StrgWrite(': vorher: ');
      Print_Pointer(OldPtrs[i]);
      StrgWrite('; jetzt: ');
      {$IFDEF DOS}
      IF (i=$23) THEN
        temp:=LONGINT(Prog_Vec_23h)
      ELSE IF (i=$24) THEN
        temp:=LONGINT(Prog_Vec_24h)
      ELSE IF (i=$1B) THEN
        temp:=LONGINT(Prog_Vec_1bh)
      ELSE
      {$ENDIF}
        temp:=NewPtrs^[i];
      Print_Pointer(temp);
      StrgWrite(#13#10);
      Difference_Found:=TRUE
    END;
  IF NOT Difference_Found THEN
    StrgWrite('Alle Interrupt-Vektoren'+
              ' sind unverndert.'#13#10);
  Wait4Ctrl
END;

FUNCTION Popup_Safe:BOOLEAN;
BEGIN
  Popup_Safe:=
  (Video_Mode=Acceptable_Video_Mode)
  AND (Active_Page=0)
END;

FUNCTION Show:BOOLEAN;FAR;

BEGIN
  IF Popup_Safe THEN BEGIN
    Save_Screen;
    ClrScr;
    Swap_Cursor;
    Print_Results;
    Swap_Cursor;
    Restore_Screen;
    Show:=TRUE
  END
  ELSE
    Show:=FALSE
END;

BEGIN {Hauptprogramm}
  StrgWrite(Copyright);
  IF Setup_TSR(Show,Alt+ShiftRight,400) THEN BEGIN
    StrgWrite('Bitte drcken Sie <Alt-ShiftRight>,'
            +#13#10'um nderungen in der '
            +'Interrupt-Belegung '
            +'anzuzeigen!'#13#10);
    NewPtrs:=NIL;
    OldPtrs:=NewPtrs^; {Interrupt-Vektoren}
    {von DOS wiederhergestellte Vektoren}
    OldPtrs[$23]:=LONGINT(Ptr(PrefixSeg,$0E)^);
    OldPtrs[$24]:=LONGINT(Ptr(PrefixSeg,$12)^);
    Make_Resident_Without_Heap
  END
END.
