USES WinDos, WinProcs, WinCrt;

TYPE
  tProtRegisters = RECORD
    EDI, ESI, EBP, Res, EBX, EDX, ECX, EAX: LONGINT;
    Flags, ES, DS, FS, GS, IP, CS, SP, SS: WORD;
  END;

VAR
  Regs: tRegisters;
  CallRegs: tProtRegisters;

BEGIN
  InitWinCrt;

  (* Ist DPMI installiert ?      *)
  Regs.AX := $1686;    
  Intr ($2F, Regs);
  WriteLn ('Wert des AX-Registers : ',Regs.AX);
  IF (Regs.AX = 0) THEN BEGIN
    WriteLn ('Programm luft im DPMI protected mode');
    Regs.AX := $0300;  (* Simulate Real Mode Interrupt *)
    Regs.BL := $33;    (* Maustreiber - Interrupt 33h  *)
    Regs.BH := 0;      (* Flags = 0                    *)
    Regs.CX := 0;      (* Anzahl zu kopierender Worte  *)
    CallRegs.EAX := $24;   (* Maus initialisieren      *)
    Regs.ES := Seg(CallRegs);   (* Selektor            *)
    Regs.DI := Ofs(CallRegs);   (* Offset auf CallRegs *)
    Intr ($31, Regs);           (* und ab...           *)

    IF NOT Odd(CallRegs.Flags) THEN BEGIN
      WriteLn ('Aufruf erfolgreich ');
      WriteLn ('Major Version = ', Hi(LoWord(CallRegs.EBX)));
      WriteLn ('Minor Version = ', Lo(LoWord(CallRegs.EBX)));
      WriteLn ('Mouse Type    = ', Hi(LoWord(CallRegs.ECX)));
      WriteLn ('IRQ used      = ', Lo(LoWord(CallRegs.ECX)));
    END ELSE WriteLn ('Aufruf nicht erfolgreich ');
  END
  ELSE WriteLn ('DPMI nicht installiert => Windows im Real Mode');
  ReadLn;
  DoneWinCrt;
END.
