PROGRAM PlayWave;

{$R Play}

(* USES WObjects, WinTypes, WinProcs, Win31, MMSystem, ShellAPI; *)
USES WinTypes, WinProcs, OWindows, ODialogs, Win31, MMSystem, ShellAPI;

CONST
  sc_About = 101;

TYPE
  pDragWin = ^tDragWin;
  tDragWin = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE GetWindowClass(VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE wmSysCommand (VAR Msg: tMessage); VIRTUAL wm_First + wm_SysCommand;
    PROCEDURE wmDropFiles (VAR Message: tMessage); VIRTUAL wm_First + wm_DropFiles;
    PROCEDURE wmQueryOpen (VAR Message: tMessage); VIRTUAL wm_First + wm_QueryOpen;
  END;

  tDragApp = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

CONSTRUCTOR tDragWin.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.Menu := LoadMenu (hInstance, 'MyMenu');
  Attr.ExStyle := ws_ex_AcceptFiles;
END;

PROCEDURE tDragWin.SetupWindow;
VAR
  SysMenu: hMenu;
BEGIN
  inherited SetupWindow;
  SysMenu := GetSystemMenu (hWindow, FALSE);
  RemoveMenu (SysMenu, sc_Restore, mf_ByCommand);
  RemoveMenu (SysMenu, sc_TaskList, mf_ByCommand);
  RemoveMenu (SysMenu, sc_Size, mf_ByCommand);
  RemoveMenu (SysMenu, sc_Maximize, mf_ByCommand);
  RemoveMenu (SysMenu, sc_Minimize, mf_ByCommand);
  AppendMenu (SysMenu, mf_String, sc_About, '&About...');
END;

PROCEDURE tDragWin.GetWindowClass(VAR aWndClass : tWndClass);
BEGIN
  inherited GetWindowClass(aWndClass);
  aWndClass.hIcon := LoadIcon(hInstance, 'PlayIt');
END;

PROCEDURE tDragWin.wmSysCommand (VAR Msg: tMessage);
VAR
  Dialog: pDialog;
BEGIN
  CASE Msg.wParam OF
    sc_About: BEGIN
      Dialog := New (pDialog, Init(@Self, 'About'));
      Application^.ExecDialog (Dialog);
    END;
    ELSE DefWndProc (Msg);
  END;
END;

PROCEDURE tDragWin.wmQueryOpen (VAR Message: tMessage);
BEGIN
  Message.Result := 0;
END;

PROCEDURE tDragWin.wmDropFiles (VAR Message: tMessage);
VAR
  wFilesDropped, x, wSize: WORD;
  npszPathName: pChar;
  DragHandle: tHandle;
BEGIN
  (* Get the number of pathnames that are being dropped on *)
  wFilesDropped := DragQueryFile (tHandle(Message.wParam), $FFFF, NIL, 0);

  FOR x := 0 TO (wFilesDropped-1) DO BEGIN
    (* Get the length of the pathname *)
    DragHandle := tHandle(Message.wParam);
    wSize := DragQueryFile (DragHandle, x, NIL, 0) +1;

    (* Allocate a block of memory large enough for the pathname *)
    GetMem(npszPathName, wSize);
    IF (npszPathName <> NIL) THEN
    BEGIN
      (* Copy the pathname into our local buffer *)
      DragQueryFile (DragHandle, x, npszPathName, wSize);
      sndPlaySound (npszPathName, snd_Async);
      FreeMem (npszPathName, wSize);
    END
  END;
  (* Free the memory block containing the pathnames  *)
  DragFinish (DragHandle);
END;

PROCEDURE tDragApp.InitMainWindow;
BEGIN
  MainWindow := New (pDragWin, Init (NIL, 'PlayWaves'));
END;

VAR
  DragApp: tDragApp;

BEGIN
  CmdShow := sw_ShowMinimized;
  DragApp.Init ('PlayWaves');
  DragApp.Run;
  DragApp.Done;
END.
