PROGRAM ReeMemory;
{$M 8192,4096}
{$R REEMEM}
USES WinTypes, WinProcs, WObjects, Strings;

CONST
  idm_About      = 100;

TYPE
  pReeWindow = ^tReeWindow;
  tReeWindow = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE wmTimer (VAR Msg: tMessage); VIRTUAL wm_First + wm_Timer;
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE Destroy; VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage);
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE wmSysCommand (VAR Msg: tMessage); VIRTUAL wm_First + wm_SysCommand;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  FreeMem: tMyApplication;
  FreeMemory, PrevMemory: LONGINT;

CONSTRUCTOR tReeWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.w := 120;
  Attr.h := 25;
  Attr.Style := Attr.Style XOR (ws_MaximizeBox + ws_ThickFrame + ws_DlgFrame);
END;

PROCEDURE tReeWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon(hInstance, 'REEMEM');
END;

PROCEDURE tReeWindow.SetupWindow;
BEGIN
  tWindow.SetupWindow;
  SetTimer (hWindow, 1, 500, NIL);
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_Separator, 0, NIL);
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_String, idm_About, 'About ReeMem...');
END;

PROCEDURE tReeWindow.Destroy;
BEGIN
  tWindow.Destroy;
  KillTimer (hWindow, 1);
END;

PROCEDURE tReeWindow.wmTimer (VAR Msg: tMessage);
VAR
  pcAvailMem: ARRAY [0..12] OF CHAR;
  StAvailMem: STRING[10];
  LA: ARRAY [0..2] OF WORD;
BEGIN
  FreeMemory := GetFreeSpace(0);
  IF (FreeMemory <> PrevMemory) THEN BEGIN
    LA[0] := FreeMemory DIV 1000000;
    LA[1] := (FreeMemory MOD 1000000) DIV 1000;
    LA[2] := FreeMemory MOD 1000;
    wvSprintF (pcAvailMem, '%02d.%003d.%003d',LA);
    SetWindowText (hWindow, pcAvailMem);
  END;
  PrevMemory := FreeMemory;
 (* BringWindowToTop (HWindow); *)
END;

PROCEDURE tReeWindow.About (VAR Msg: tMessage);
VAR Dialog: tDialog;
BEGIN
  Dialog.Init(@Self, 'AboutBox');
  Dialog.Execute;
  Dialog.Done;
END;

PROCEDURE tReeWindow.wmSysCommand (VAR Msg: tMessage);
BEGIN
  CASE Msg.wParam OF
    idm_About: About (Msg);
    ELSE DefWndProc (Msg);
  END;
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New(pReeWindow, Init(NIL,'ReeMem'));
END;

BEGIN
  FreeMem.Init ('ReeMem');
  FreeMem.Run;
  FreeMem.Done;
END.
